package jedi.example;

public class StormtrooperStaticClosureFactory {
	private static IStormtrooperClosureFactory $DELEGATE = new StormtrooperClosureFactory();

	public static void setDelegate(IStormtrooperClosureFactory newDelegate) {
		jedi.assertion.Assert.assertNotNull(newDelegate, "newDelegate must not be null");
		$DELEGATE = newDelegate;
	}

	public static void useDefaultDelegate() {
		setDelegate(new StormtrooperClosureFactory());
	}
	/**
	 * @see jedi.example.Stormtrooper#attack
	 */
	public static  jedi.functional.Command<jedi.example.Stormtrooper> attackCommand(final jedi.example.RebelBase base) {
		return $DELEGATE.attackCommand(base);
	}
	/**
	 * @see jedi.example.Stormtrooper#attack
	 */
	public static  jedi.functional.Command<jedi.example.RebelBase> attackProxyCommand(final jedi.example.Stormtrooper $receiver) {
		return $DELEGATE.attackProxyCommand($receiver);
	}
	/**
	 * @see jedi.example.Stormtrooper#getDistance
	 */
	public static  jedi.functional.Functor<jedi.example.Stormtrooper, java.lang.Integer> getDistanceFunctor(final jedi.example.RebelBase base) {
		return $DELEGATE.getDistanceFunctor(base);
	}
	/**
	 * @see jedi.example.Stormtrooper#getDistance
	 */
	public static  jedi.functional.Functor<jedi.example.RebelBase, java.lang.Integer> getDistanceProxyFunctor(final jedi.example.Stormtrooper $receiver) {
		return $DELEGATE.getDistanceProxyFunctor($receiver);
	}
	/**
	 * @see jedi.example.Stormtrooper#getNearestBase
	 */
	public static  jedi.functional.Functor<jedi.example.Stormtrooper, jedi.example.RebelBase> getNearestBaseIntFunctor(final int limit) {
		return $DELEGATE.getNearestBaseIntFunctor(limit);
	}
	/**
	 * @see jedi.example.Stormtrooper#getNearestBase
	 */
	public static  jedi.functional.Functor<java.lang.Integer, jedi.example.RebelBase> getNearestBaseIntProxyFunctor(final jedi.example.Stormtrooper $receiver) {
		return $DELEGATE.getNearestBaseIntProxyFunctor($receiver);
	}
	/**
	 * @see jedi.example.Stormtrooper#getNearestBase
	 */
	public static  jedi.functional.Functor<jedi.example.Stormtrooper, jedi.example.RebelBase> getNearestBaseIntegerFunctor(final java.lang.Integer limit) {
		return $DELEGATE.getNearestBaseIntegerFunctor(limit);
	}
	/**
	 * @see jedi.example.Stormtrooper#getNearestBase
	 */
	public static  jedi.functional.Functor<java.lang.Integer, jedi.example.RebelBase> getNearestBaseIntegerProxyFunctor(final jedi.example.Stormtrooper $receiver) {
		return $DELEGATE.getNearestBaseIntegerProxyFunctor($receiver);
	}
	/**
	 * @see jedi.example.Stormtrooper#isWithinRange
	 */
	public static  jedi.functional.Filter<jedi.example.Stormtrooper> isWithinRangeFilter(final jedi.example.RebelBase base) {
		return $DELEGATE.isWithinRangeFilter(base);
	}
	/**
	 * @see jedi.example.Stormtrooper#isWithinRange
	 */
	public static  jedi.functional.Filter<jedi.example.RebelBase> isWithinRangeProxyFilter(final jedi.example.Stormtrooper $receiver) {
		return $DELEGATE.isWithinRangeProxyFilter($receiver);
	}
}
